summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Steven Voges <svoges.sbo@gmail.com>2022-09-24 21:07:42 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2022-09-25 13:59:46 +0700
commit329f94c2d218d4e5d81b754b3966cbcc6afd3154 (patch)
tree12978a0768c032ac305c4bd17331bb04a7524294
parent52fd803df4120442e312be365e560124cb9ed6c0 (diff)
downloadslackbuilds-329f94c2d218d4e5d81b754b3966cbcc6afd3154.tar.gz
slackbuilds-329f94c2d218d4e5d81b754b3966cbcc6afd3154.tar.xz
libraries/zycore-c: Added (LibC Fallback Library)
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/zycore-c/README21
-rw-r--r--libraries/zycore-c/slack-desc19
-rw-r--r--libraries/zycore-c/zycore-c.SlackBuild105
-rw-r--r--libraries/zycore-c/zycore-c.info10
4 files changed, 155 insertions, 0 deletions
diff --git a/libraries/zycore-c/README b/libraries/zycore-c/README
new file mode 100644
index 0000000000..ea6d2f598e
--- /dev/null
+++ b/libraries/zycore-c/README
@@ -0,0 +1,21 @@
+Zyan Core Library for C
+
+Internal library providing platform independent types, macros and a
+fallback for environments without LibC.
+
+Features:
+ * Platform independent types
+ - Integer types (ZyanU8, ZyanI32, ZyanUSize, ...)
+ - ZyanBool (+ ZYAN_FALSE, ZYAN_TRUE)
+ - ZYAN_NULL
+ * Macros
+ - Compiler/Platform/Architecture detection
+ - Asserts and static asserts
+ - Utils (ARRAY_LENGTH, FALLTHROUGH, UNUSED, ...)
+ * Common types
+ - ZyanBitset
+ - ZyanString/ZyanStringView
+ * Container types
+ - ZyanVector
+ - ZyanList
+ * LibC abstraction (WiP)
diff --git a/libraries/zycore-c/slack-desc b/libraries/zycore-c/slack-desc
new file mode 100644
index 0000000000..94b0ee3047
--- /dev/null
+++ b/libraries/zycore-c/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+zycore-c: zycore-c (LibC Fallback Library)
+zycore-c:
+zycore-c: Internal library providing platform independent types, macros and a
+zycore-c: fallback for environments without LibC.
+zycore-c:
+zycore-c: Homepage: https://github.com/zyantific/zycore-c
+zycore-c:
+zycore-c:
+zycore-c:
+zycore-c:
+zycore-c:
diff --git a/libraries/zycore-c/zycore-c.SlackBuild b/libraries/zycore-c/zycore-c.SlackBuild
new file mode 100644
index 0000000000..bf52c878d6
--- /dev/null
+++ b/libraries/zycore-c/zycore-c.SlackBuild
@@ -0,0 +1,105 @@
+#!/bin/bash
+
+# Slackware build script for zycore-c
+
+# Copyright 2022 Steven Voges <Oregon, USA>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=zycore-c
+VERSION=${VERSION:-1.2.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DZYAN_WHOLE_PROGRAM_OPTIMIZATION=ON \
+ -DZYCORE_BUILD_SHARED_LIB=ON \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/zycore-c/zycore-c.info b/libraries/zycore-c/zycore-c.info
new file mode 100644
index 0000000000..94e3a8e210
--- /dev/null
+++ b/libraries/zycore-c/zycore-c.info
@@ -0,0 +1,10 @@
+PRGNAM="zycore-c"
+VERSION="1.2.0"
+HOMEPAGE="https://github.com/zyantific/zycore-c"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/zyantific/zycore-c/archive/v1.2.0/zycore-c-1.2.0.tar.gz"
+MD5SUM_x86_64="0ea1369e1e5e2e801055fe9b2b99651b"
+REQUIRES=""
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"